Index: /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIToolBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/extensions/QIToolBar.cpp	(revision 88862)
@@ -111,8 +111,8 @@
 
         /* Prepare gradient: */
-        const QColor backgroundColor = palette().color(QPalette::Active, QPalette::Mid);
+        const QColor backgroundColor = QApplication::palette().color(QPalette::Active, QPalette::Mid);
         QLinearGradient gradient(rectangle.topLeft(), rectangle.bottomLeft());
-        gradient.setColorAt(0,   backgroundColor.lighter(130));
-        gradient.setColorAt(1,   backgroundColor.lighter(125));
+        gradient.setColorAt(0, backgroundColor.lighter(130));
+        gradient.setColorAt(1, backgroundColor.lighter(125));
 
         /* Fill background: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerTextEdit.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerTextEdit.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerTextEdit.cpp	(revision 88862)
@@ -203,5 +203,5 @@
 
     /* Prepare modified standard palette: */
-    QPalette pal = style() ? style()->standardPalette() : palette(); // fallback if no style exist.
+    QPalette pal = style() ? style()->standardPalette() : QApplication::palette(); // fallback if no style exist.
     pal.setColor(QPalette::Inactive, QPalette::Highlight, pal.color(QPalette::Active, QPalette::Highlight));
     pal.setColor(QPalette::Inactive, QPalette::HighlightedText, pal.color(QPalette::Active, QPalette::HighlightedText));
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManager.cpp	(revision 88862)
@@ -2225,5 +2225,5 @@
         /* Make sure menu-bar fills own solid background: */
         menuBar()->setAutoFillBackground(true);
-        QPalette pal = menuBar()->palette();
+        QPalette pal = QApplication::palette();
         const QColor color = pal.color(QPalette::Active, QPalette::Mid).lighter(160);
         pal.setColor(QPalette::Active, QPalette::Button, color);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/UIVirtualBoxManagerWidget.cpp	(revision 88862)
@@ -568,5 +568,5 @@
 {
     setAutoFillBackground(true);
-    QPalette pal = palette();
+    QPalette pal = QApplication::palette();
 #ifdef VBOX_WS_MAC
     const QColor color = pal.color(QPalette::Active, QPalette::Mid).lighter(145);
@@ -696,5 +696,5 @@
 
             /* Adjust splitter colors according to main widgets it splits: */
-            m_pSplitter->configureColor(palette().color(QPalette::Active, QPalette::Midlight).darker(110));
+            m_pSplitter->configureColor(QApplication::palette().color(QPalette::Active, QPalette::Midlight).darker(110));
             /* Set the initial distribution. The right site is bigger. */
             m_pSplitter->setStretchFactor(0, 2);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 88862)
@@ -559,5 +559,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
     /* Selected-item background: */
@@ -665,5 +665,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor strokeColor;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGroup.cpp	(revision 88862)
@@ -1665,11 +1665,10 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
-    const QColor strokeColor = pal.color(QPalette::Active,
-                                         model()->selectedItems().contains(this) ?
-                                         QPalette::Highlight : QPalette::Midlight).darker(headerDarkness() + 10);
+    const QColor frameColor = QApplication::palette().color(QPalette::Active,
+                                                            model()->selectedItems().contains(this) ?
+                                                            QPalette::Highlight : QPalette::Midlight).darker(headerDarkness() + 10);
 
     /* Create/assign pen: */
-    QPen pen(strokeColor);
+    QPen pen(frameColor);
     pen.setWidth(0);
     pPainter->setPen(pen);
@@ -1705,7 +1704,7 @@
 
     /* Configure painter color: */
-    pPainter->setPen(palette().color(QPalette::Active,
-                                     model()->selectedItems().contains(this) ?
-                                     QPalette::HighlightedText : QPalette::ButtonText));
+    pPainter->setPen(QApplication::palette().color(QPalette::Active,
+                                                   model()->selectedItems().contains(this) ?
+                                                   QPalette::HighlightedText : QPalette::ButtonText));
 
     /* Paint name: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemMachine.cpp	(revision 88862)
@@ -903,5 +903,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
     /* Selected-item background: */
@@ -1045,5 +1045,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor strokeColor;
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/details/UIDetailsElement.cpp	(revision 88862)
@@ -1472,5 +1472,5 @@
 
     /* Acquire palette: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
     /* Paint default background: */
@@ -1516,6 +1516,6 @@
 
     /* Paint frame: */
-    const QColor strokeColor = palette().color(QPalette::Active, QPalette::Mid).lighter(m_iDefaultToneStart);
-    QPen pen(strokeColor);
+    const QColor frameColor = QApplication::palette().color(QPalette::Active, QPalette::Mid).lighter(m_iDefaultToneStart);
+    QPen pen(frameColor);
     pen.setWidth(0);
     pPainter->setPen(pen);
@@ -1541,5 +1541,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     const QColor buttonTextColor = pal.color(QPalette::Active, QPalette::ButtonText);
     const QColor linkTextColor = pal.color(QPalette::Active, QPalette::Link);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/manager/tools/UIToolsItem.cpp	(revision 88862)
@@ -709,5 +709,5 @@
 
     /* Prepare variables: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
     /* Selection background: */
@@ -817,5 +817,5 @@
 
     /* Prepare colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor strokeColor;
 
@@ -851,5 +851,5 @@
     const int iMargin = data(ToolsItemData_Margin).toInt();
     const int iSpacing = data(ToolsItemData_Spacing).toInt();
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
     /* Selected or hovered item foreground: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/snapshots/UISnapshotDetailsWidget.cpp	(revision 88862)
@@ -252,5 +252,5 @@
 
     /* Prepare palette colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor color0 = pal.color(QPalette::Window);
     QColor color1 = pal.color(QPalette::Window).lighter(110);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuBarEditorWindow.cpp	(revision 88862)
@@ -674,5 +674,5 @@
 
     /* Prepare palette colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor color0 = pal.color(QPalette::Window);
     QColor color1 = pal.color(QPalette::Window).lighter(110);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuToolBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMenuToolBar.cpp	(revision 88862)
@@ -249,5 +249,5 @@
     }
     QRect backgroundRect = rect();
-    QColor backgroundColor = palette().color(QPalette::Window);
+    QColor backgroundColor = QApplication::palette().color(QPalette::Window);
     QLinearGradient headerGradient(backgroundRect.bottomLeft(), backgroundRect.topLeft());
     headerGradient.setColorAt(0, backgroundColor.darker(120));
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIMiniToolBar.cpp	(revision 88862)
@@ -266,5 +266,5 @@
     }
     QRect backgroundRect = rect();
-    QColor backgroundColor = palette().color(QPalette::Window);
+    QColor backgroundColor = QApplication::palette().color(QPalette::Window);
     QLinearGradient headerGradient(backgroundRect.bottomLeft(), backgroundRect.topLeft());
     headerGradient.setColorAt(0, backgroundColor.darker(120));
@@ -890,5 +890,5 @@
         /* Configure own background: */
         QPalette pal = m_pToolbar->palette();
-        pal.setColor(QPalette::Window, palette().color(QPalette::Window));
+        pal.setColor(QPalette::Window, QApplication::palette().color(QPalette::Window));
         m_pToolbar->setPalette(pal);
         /* Configure child connections: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupBox.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupBox.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupBox.cpp	(revision 88862)
@@ -282,5 +282,5 @@
     painter.setClipRect(pEvent->rect());
 
-    QPalette pal = palette();
+    QPalette pal = QApplication::palette();
     painter.setClipPath(*m_pLabelPath);
     QColor base = pal.color(QPalette::Active, QPalette::Window);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupPane.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupPane.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIPopupPane.cpp	(revision 88862)
@@ -240,5 +240,5 @@
 {
     /* Prepare palette: */
-    QPalette pal = palette();
+    QPalette pal = QApplication::palette();
     pal.setColor(QPalette::Window, QApplication::palette().color(QPalette::Window));
     setPalette(pal);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISearchLineEdit.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISearchLineEdit.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISearchLineEdit.cpp	(revision 88862)
@@ -93,5 +93,5 @@
 void UISearchLineEdit::colorBackground(bool fWarning)
 {
-    QPalette mPalette = palette();
+    QPalette mPalette = QApplication::palette();
     /** Make sure we reset color. */
     if (!fWarning || !m_fMark)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UISlidingToolBar.cpp	(revision 88862)
@@ -165,5 +165,5 @@
                 /* Configure child-widget: */
                 QPalette pal2 = m_pWidget->palette();
-                pal2.setColor(QPalette::Window, palette().color(QPalette::Window));
+                pal2.setColor(QPalette::Window, QApplication::palette().color(QPalette::Window));
                 m_pWidget->setPalette(pal2);
                 /* Using abstract (old-style) connection here(!) since the base classes can be different: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIStatusBarEditorWindow.cpp	(revision 88862)
@@ -499,5 +499,5 @@
 
     /* Prepare palette colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor color0 = pal.color(QPalette::Window);
     QColor color1 = pal.color(QPalette::Window).lighter(110);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UITabBar.cpp	(revision 88862)
@@ -247,5 +247,5 @@
 
     /* Prepare palette colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     const QColor color0 = m_fCurrent
                         ? pal.color(QPalette::Shadow).darker(110)
@@ -368,5 +368,5 @@
 
     /* Prepare palette colors: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     const QColor color0 = m_fCurrent ? pal.color(QPalette::Base)
                         : m_fHovered ? pal.color(QPalette::Base).darker(102)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIToolBox.cpp	(revision 88862)
@@ -366,5 +366,5 @@
     pNewPage->setTitle(strTitle);
 
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
     QColor tabBackgroundColor = pal.color(QPalette::Active, QPalette::Highlight).lighter(130);
     pNewPage->setTitleBackgroundColor(tabBackgroundColor);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsScrollBar.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsScrollBar.cpp	(revision 88861)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/widgets/graphics/UIGraphicsScrollBar.cpp	(revision 88862)
@@ -153,5 +153,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
 #ifdef VBOX_WS_MAC
@@ -991,5 +991,5 @@
 
     /* Prepare color: */
-    const QPalette pal = palette();
+    const QPalette pal = QApplication::palette();
 
 #ifdef VBOX_WS_MAC